package report;

import java.util.Map;
import java.util.Set;

import routing.NDN.DataReport;
import routing.NDN.DataReport.Data;
import routing.NDN.Interest;
import routing.NDN.InterestReport;


public class NamedDataReport extends Report {

	public static int InInterests = 0;
	public static int OutInterests = 0;
	public static int GenInterests = 0;
	public static int DropInterests = 0;
	public static int InData = 0;	
	public static int OutData = 0;
	public static int DropData = 0;	
	public static int InNacks = 0;
	public static int OutNacks = 0;
	public static int SastifiedInterests = 0;
	
	
	DataReport R;
	InterestReport I;
	writeReportToFile wtf;

	public NamedDataReport()
	{
		init();
	
		this.R = DataReport.getInstance();
		wtf = writeReportToFile.getInstance();
	}
		
	@Override
	public void done()
	{
	
		numberofDataDelivered();
		numberOfDataSent();
		wtf.writeReportend();
		System.out.println("AVG Message Interest Delay: " + avgMessageDelayLatency());
		System.out.println("AVG Message Interest Delay Alternative: " + avgMessageDelayLatencyAlternative());
		System.out.println("Nmero de interesses enviados pelo consumidor: " + I.numberInterestsSendOut);
		System.out.println("Interesses Satifeitos (numero de dados recebidos): " + I.numberInterestsSastified);
		System.out.println("Numero de dados enviados pelo produtor/intermedirio: " + R.getnrSendOutData());
		System.out.println("Numero de dados recebidor pelo consumidor: " + R.getnrDeliveredData());
		System.out.println("AVG Message Data Delay: " + avgMessageDataDelayLatency());
		System.out.println("Nmero de interesses satisfeitos no n: " + I.numberInterestsSastifiedinNode);
		System.out.println("Nmero Mdio de Saltos: " + getIntAverage(R.hopCounts));
		System.out.println("Mdiana de Saltos: " + getIntMedian(R.hopCounts));
//		System.out.println("Nmero Mdio de Saltos Interesse: " + getIntAverage(I.getNrHops()));
		
		

	}
	
	
	// tempo entre o interesse ser transmitido na rede e os dados chegarem
	
	public double avgMessageDelayLatency()
	{
		double avgMessageDelayLatency = 0;
		Set<String> idsInterests = I.LI.keySet();
		int nrInterests = 0;
		double sumLatency = 0;
		double aux =0;
			
		// percorrer todos os interesses
		for (String idsInterest : idsInterests)
		{
			if(I.LI.get(idsInterest).isSastified)
			{
					double di = I.LI.get(idsInterest).timeSatisfied;
					double ci = I.LI.get(idsInterest).timeSendOut;
					aux = di-ci;
					sumLatency = sumLatency + aux;
					nrInterests ++;
			}
			
		}
		avgMessageDelayLatency = sumLatency/nrInterests;	
		return avgMessageDelayLatency;	
	}
	
	
	
	public double avgMessageDelayLatencyAlternative()
	{
		double avgMessageDataDelayLatency = 0;
		
		Map<String, routing.NDN.InterestReport.Data> p = I.PITSast;
		double sumLatency = 0;
		double aux =0;
		int dataIn =0;
		
		if (!p.isEmpty())
		{
			for (String k  : p.keySet())
			{
				if(k!=null)
				{
					double di = p.get(k).timeDelivered;
					double ci = p.get(k).timeCreate;
					aux = di - ci;
					sumLatency = sumLatency + aux;
					dataIn++;
				}
				
			}

		}
		
		//System.out.println("dados recebidos pelo consumidor : " + dataIn);
		return avgMessageDataDelayLatency = sumLatency/dataIn;			
	}
	
	
	
	public double avgMessageDataDelayLatency()
	{
		double avgMessageDataDelayLatency = 0;
		Map<String, Data> s = R.getPC();
		double sumLatency = 0;
		double aux =0;
		int dataIn =0;
		
		if (!s.isEmpty())
		{
			for (String k  : s.keySet())
			{
				if(s.get(k).isDelivered)
				{
					double di = s.get(k).timeDelivered;
					double ci = s.get(k).timeSendOut;
					aux = di - ci;
					sumLatency = sumLatency + aux;
					dataIn++;
				}
				
			}

		}
			
		return avgMessageDataDelayLatency = sumLatency/dataIn;			
	}
	
	
	public int numberReplicateInterests()
	{
		return warmupTime;
		
	}
	
	public int numberReplicateData()
	{
		return warmupTime;
		
	}
	
	// numero de interesses enviados
	// -> se o n  subscritor e ver se variavel de sendOut = true
	//    -> se true incrementar 
	
	public void numberSendOutInterests(Map<String, Interest> li)
	{
		Set<String> idsInterests = li.keySet(); 		
		// percorrer todos os interesses;
		for (String idsInterest : idsInterests)
		{
			if(li.get(idsInterest).getsubscriberState()) // se for subscritor
			{
				if (li.get(idsInterest).getIsSendOut()) OutInterests ++; // 
			}
		}
	}
	
	
	// numero de Interesses satisfeitos = numero de dados recebidos pelo consumidor
	public void numberOfInterestsSastified(Map<String, Interest> li)
	{
		Set<String> idsInterests = li.keySet(); 		
		// percorrer todos os interesses
		for (String idsInterest : idsInterests)
		{
			if(li.get(idsInterest).getsubscriberState())
			{
				if (li.get(idsInterest).getIsSastified()) SastifiedInterests ++;
				//if (li.get(idsInterest).getIsSendOut()) OutInterests ++;
			}
		}
	}
	
	// numero de dados enviados pelo produtor
	public void numberOfDataSent()
	{
		
		Map<String, Data> s = R.getPC();

		if (!s.isEmpty())
		{
			for (String k  : s.keySet())
			{
				if(s.get(k).isSendOut) OutData ++ ;
			}
		}
	}
	
	
	// numero de dados recebido pelo consumidor
	public void numberofDataDelivered()
	{
		Map<String, Data> s = R.getPC();
		
		if (!s.isEmpty())
		{
			for (String k  : s.keySet())
			{
				if(s.get(k).isDelivered) InData ++;
			}
		}
	}
	

	
}