package routing.NDN;

import java.util.ArrayList;

import core.DTNHost;

public class Interest {

	private String id;
	/** Name of the interest */
	private String name;
	
	/** Number of requests of the interest */
	private int nrOfRequests = 0;
	/** All hosts which required the interest */
	private  ArrayList<DTNHost> hosts;
	
	/** time when interest was generated */
	private double generatedTime;
	
	/** time when interest was sastified */
	private double sastifiedTimeInterest;
	
	
	/** time when interest was send out */
	private double outTimeInterest;
	
	private boolean isSastified;
	private boolean isSendOut;
	private boolean isSubscriber;
	
	public Interest(String name, int nrOfRequests, ArrayList<DTNHost> h, double t){
		
		this.name = name;
		this.nrOfRequests = nrOfRequests;
		this.hosts= h;
		this.generatedTime = t;
		this.isSendOut = false;

	}
	
	public Interest(){
		this.id = "";
		this.name = "";
		this.nrOfRequests = 0;

	}

	public String getId(){
		return this.id;
	}
	
	public String getName(){
		return this.name;
	}
	
	public int getNrOfRequests(){
		return this.nrOfRequests;
	}
	

	public void setId(String id){
		this.id = id;
	}
	
	public void setName(String name){
		this.name = name;
	}
	
	public void updateNrofRequests(){
		this.nrOfRequests++;
	}
	

	public void putHost(DTNHost host)
	{
		this.hosts.add(host);
	}
	
	
	public ArrayList<DTNHost> getAllHosts()
	{
		return this.hosts;
	}
	
	
	public boolean checkifHost(DTNHost host)
	{
		return this.hosts.contains(host);
	}
	
	public boolean removeHost(DTNHost host)
	{
		return this.hosts.remove(host);
	}
	
	
	
	public void setTime(double time)
	{
		this.generatedTime = time;
	}
	
	public double getGenTime()
	{
		return this.generatedTime;
	}
	
	
	public void setsastifiedTimeInterest(double time)
	{
		this.sastifiedTimeInterest = time;
		this.isSastified = true;
	}
	
	
	public double getsastifiedTimeInterest()
	{
		return this.sastifiedTimeInterest;
	}
	
	public void setoutTimeInterest(double time) 
	{
		this.isSendOut = true;
		this.outTimeInterest = time;	
	}
	
	public double getoutTimeInterest() 
	{
		return this.outTimeInterest;	
	}
	
	public void setsubscriberState(boolean s)
	{
		this.isSubscriber = s;
	}
	

	
	public boolean getsubscriberState()
	{
		return this.isSubscriber;
	}
	
	
	
	public boolean getIsSastified()
	{
		return this.isSastified;
	}
	
	
	public boolean getIsSendOut()
	{
		return this.isSendOut;
	}
	
}
