/* 
 /* 
 * Copyright 2015 Universidade do Minho, GCOM
 * Modified by Paulo Duarte.
 * Released under GPLv3. See LICENSE.txt for details. 
 */

package routing;

import java.util.ArrayList;

import core.DTNHost;

public class PITEntries {

	private String identifier;
	
	/** All hosts which required the interest */
	private  ArrayList<DTNHost> hosts;
	
	/** time when interest was generated */
	//public double generatedTime;
	
	public double timeCreated;
	
	public double ttl;
	
	private double lastProbability;
	
	public boolean isSubscriver;
	
	public PITEntries(String id, ArrayList<DTNHost> h, double t, double timetolive, boolean isSub){
		
		this.identifier = id;
		this.hosts= h;
		this.timeCreated = t;
		this.ttl = timetolive;
		this.isSubscriver = isSub;
	}
	
	public PITEntries(){
		this.identifier = "";
		this.hosts = null;
		this.timeCreated = 0;
		this.lastProbability = 0;
		this.ttl = 0;
		this.isSubscriver = false;
	}

	
	public String getId(){
		return this.identifier;
	}
	
	public void setId(String id){
		this.identifier = id;
	}
	
	
	
	public void addHost(DTNHost host)
	{
		this.hosts.add(host);
	}
	
	
	public ArrayList<DTNHost> getAllHosts()
	{
		return this.hosts;
	}
	
	
	public boolean checkifHost(DTNHost host)
	{
		return this.hosts.contains(host);
	}
	
	public boolean removeHost(DTNHost host)
	{
		return this.hosts.remove(host);
	}
	
	
	
	public void setTime(double time)
	{
		this.timeCreated = time;
	}
	
	public double getTime(double time)
	{
		return this.timeCreated;
	}
	
	
	public double getLastProb()
	{
		return this.lastProbability;
	}
	
	public void setLastProb(double value)
	{
		this.lastProbability = value;
	}
	
}
